//+------------------------------------------------------------------+
//|                                             Angle of average.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property  copyright "mladen"

#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Green
#property  indicator_color2  Red
#property  indicator_color3  DimGray
#property  indicator_width1  2
#property  indicator_width2  2
#property  indicator_minimum 0
#property  indicator_maximum 1

//
//
//
//
//

extern string TimeFrame          = "Current time frame";
extern int    T3Period           =  34;
extern double T3Hot              =  0.7; 
extern int    T3Price            =  PRICE_CLOSE;
extern bool   T3Original         = false;
extern double AngleLevel         =   5;
extern int    AngleBars          =   6;
extern bool   alertsOn           = false;
extern bool   alertsOnCurrent    = false;
extern bool   alertsOnZeroCross  = true;
extern bool   alertsOnLevelCross = true;
extern bool   alertsSound        = false;
extern bool   alertsMessage      = true;
extern bool   alertsNotification = false;
extern bool   alertsEmail        = false;

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Buffer3[];
double t3[];
double trendz[];
double trendu[];
double trendd[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,Buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,t3);
   SetIndexBuffer(4,trendz);
   SetIndexBuffer(5,trendu);
   SetIndexBuffer(6,trendd);

      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);

      //
      //
      //
      //
      //

      IndicatorShortName(timeFrameToString(timeFrame)+" Angle of T3 ("+T3Period+","+DoubleToStr(AngleLevel,2)+","+AngleBars+")");
      IndicatorDigits(2);
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define Pi 3.141592653589793238462643
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=Bars-counted_bars;
           if (returnBars) { Buffer1[0] = limit+1; return(0); }


   //
   //
   //
   //
   //

   if (timeFrame!=Period())
   {
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for(int i=limit; i>=0; i--)
      {
       int y = iBarShift(NULL,timeFrame,Time[i]);               
          Buffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3Period,T3Hot,T3Price,T3Original,AngleLevel,AngleBars,alertsOn,alertsOnCurrent,alertsOnZeroCross,alertsOnLevelCross,alertsSound,alertsMessage,alertsNotification,alertsEmail,0,y);
          Buffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3Period,T3Hot,T3Price,T3Original,AngleLevel,AngleBars,alertsOn,alertsOnCurrent,alertsOnZeroCross,alertsOnLevelCross,alertsSound,alertsMessage,alertsNotification,alertsEmail,1,y);
          Buffer3[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",T3Period,T3Hot,T3Price,T3Original,AngleLevel,AngleBars,alertsOn,alertsOnCurrent,alertsOnZeroCross,alertsOnLevelCross,alertsSound,alertsMessage,alertsNotification,alertsEmail,2,y);
      }
      return(0);
   }

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      t3[i] = iT3(iMA(NULL,0,1,0,MODE_SMA,T3Price,i),T3Period,T3Hot,T3Original,i);
      double range = iATR(NULL,0,AngleBars*20,i);
      double angle = 0.00;
      double change=t3[i]-t3[i+AngleBars];
         if (range != 0) angle = MathArctan(change/(range*AngleBars))*180.0/Pi;

      //
      //
      //
      //
      //
      
         Buffer1[i] = EMPTY_VALUE;
         Buffer2[i] = EMPTY_VALUE;
         Buffer3[i] = 1;
            if (angle >  AngleLevel) { Buffer1[i] = 1; Buffer3[i] = EMPTY_VALUE;}
            if (angle < -AngleLevel) { Buffer2[i] = 1; Buffer3[i] = EMPTY_VALUE;}
            trendz[i] = trendz[i+1];
            trendu[i] = trendu[i+1];
            trendd[i] = trendd[i+1];
               if (angle>0)           trendz[i] =  1;
               if (angle<0)           trendz[i] = -1;
               if (angle> AngleLevel) trendu[i] =  1;
               if (angle< AngleLevel) trendu[i] = -1;
               if (angle>-AngleLevel) trendd[i] =  1;
               if (angle<-AngleLevel) trendd[i] = -1;
   }
   manageAlerts();
   return(0);
}


//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static string   alertType1 = "";
      static datetime alertTime1 = 0;
      if (alertsOnZeroCross && trendz[whichBar] != trendz[whichBar+1])
      {
         if (trendz[whichBar] ==  1) doAlert(alertType1,alertTime1,"Angle of T3 crossed level 0 up");
         if (trendz[whichBar] == -1) doAlert(alertType1,alertTime1,"Angle of T3 crossed level 0 down");
      }
      static string   alertType2 = "";
      static datetime alertTime2 = 0;
      if (alertsOnLevelCross && trendu[whichBar] != trendu[whichBar+1])
      {
         if (trendu[whichBar] ==  1) doAlert(alertType2,alertTime2,"Angle of T3 crossed upper level up");
         if (trendu[whichBar] == -1) doAlert(alertType2,alertTime2,"Angle of T3 crossed upper leve down");
      }
      static string   alertType3 = "";
      static datetime alertTime3 = 0;
      if (alertsOnLevelCross && trendd[whichBar] != trendd[whichBar+1])
      {
         if (trendd[whichBar] ==  1) doAlert(alertType3,alertTime3,"Angle of T3 crossed lower level up");
         if (trendd[whichBar] == -1) doAlert(alertType3,alertTime3,"Angle of T3 crossed lower level down");
      }
   }
}

//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message = timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+"  "+doWhat;
          if (alertsMessage)      Alert(message);
          if (alertsEmail)        SendMail(StringConcatenate(Symbol(),"Angle of T3"),message);
          if (alertsNotification) SendNotification(StringConcatenate(Symbol(),"Angle of T3 "+message));
          if (alertsSound)        PlaySound("alert2.wav");
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][6];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}